/*
 * BluSunrize
 * Copyright (c) 2017
 *
 * This code is licensed under "Blu's License of Common Sense"
 * Details can be found in the license file in the root folder of this project
 */
package blusunrize.trauma.common.utils.network;

import blusunrize.trauma.api.condition.CapabilityTrauma;
import blusunrize.trauma.api.condition.EnumLimb;
import blusunrize.trauma.api.condition.LimbCondition;
import blusunrize.trauma.api.condition.TraumaStatus;
import blusunrize.trauma.api.recovery.CapabilityRecoveryItem;
import blusunrize.trauma.api.recovery.IRecoveryItem;
import io.netty.buffer.ByteBuf;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import net.minecraftforge.common.DimensionManager;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;

/**
 * @author BluSunrize
 * @since 20.09.2017
 */
public class MessageApplyRecoveryItem implements IMessage
{
	int dimension;
	int entityID;
	EnumLimb limb;

	public MessageApplyRecoveryItem(EntityPlayer player, EnumLimb limb)
	{
		this.dimension = player.field_70170_p.field_73011_w.getDimension();
		this.entityID = player.func_145782_y();
		this.limb = limb;
	}

	public MessageApplyRecoveryItem()
	{
	}

	@Override
	public void fromBytes(ByteBuf buf)
	{
		this.dimension = buf.readInt();
		this.entityID = buf.readInt();
		this.limb = EnumLimb.values()[buf.readInt()];
	}

	@Override
	public void toBytes(ByteBuf buf)
	{
		buf.writeInt(this.dimension);
		buf.writeInt(this.entityID);
		buf.writeInt(this.limb.ordinal());
	}

	public static class HandlerServer implements IMessageHandler<MessageApplyRecoveryItem, IMessage>
	{
		@Override
		public IMessage onMessage(MessageApplyRecoveryItem message, MessageContext ctx)
		{
			World world = DimensionManager.getWorld(message.dimension);
			if(world!=null)
			{
				Entity entity = world.func_73045_a(message.entityID);
				if(entity!=null&&entity instanceof EntityPlayer)
				{
					ItemStack held = ((EntityPlayer)entity).field_71071_by.func_70445_o();
					if(!held.func_190926_b())
					{
						if(!held.func_190926_b()&&(held.func_77973_b() instanceof IRecoveryItem||held.hasCapability(CapabilityRecoveryItem.REVOVERYITEM_CAPABILITY, null)))
						{
							IRecoveryItem iRecoveryItem = held.func_77973_b() instanceof IRecoveryItem?(IRecoveryItem)held.func_77973_b(): held.getCapability(CapabilityRecoveryItem.REVOVERYITEM_CAPABILITY, null);
							TraumaStatus status = entity.getCapability(CapabilityTrauma.TRAUMA_CAPABILITY, null);
							LimbCondition limbCondition = status.getLimbCondition(message.limb);
							limbCondition.addRecoveryItem(iRecoveryItem.getIdentifier(held), iRecoveryItem.getDuration(held, (EntityPlayer)entity, limbCondition));
							int newTimer = Math.round(limbCondition.getRecoveryTimer()*iRecoveryItem.getRecoveryTimeModifier(held, (EntityPlayer)entity, limbCondition));
							limbCondition.setRecoveryTimer(newTimer);
							iRecoveryItem.onApply(held, (EntityPlayer)entity, limbCondition);
							held.func_190918_g(1);
						}
					}
				}
			}
			return null;
		}
	}
}
